<?php
/*
<!-- $Id: functions.inc,v 3.0 2006/07/24 16:26:42 jfranken Exp $ 
vim: ft=php
-->
*/

# Zugang zur Datenbank:
$DBCONNECT="mysql://phpuser:phppw@localhost/phptestdb";

# global variables:
$script=$_SERVER['SCRIPT_NAME'];
$script=preg_replace("/\?.*/","",$script); # Parameter entfernen
$script=preg_replace("/\/\//","/",$script); # Doppelte Slashes entfernen


# FUNCTIONS:

function head() { ?>
<head>
	<link rel="stylesheet" type="text/css" href="style.css">
	<title>LAMP-Anwendung</title>
	<META http-equiv="expires" content="0">
</head>
<?php }

function bodystart() { ?>
<body>
<?php }


function alert($text) {	
	# Loest einen Javascript-Alert aus
	print "<script>alert('$text')</script>\n";
}


function goto_url($url) {
# Bringt den Browser dazu, die uebergebene URL aufzurufen
	return ("
		<script type='text/javascript'> <!--
			location.href='$url';
		//--> </script>
		<a href=\"$url\">[Weiter]</a>
	");
}

function sqlgetfirstrow ($sql,$db) {
# Fuehrt die uebergebene SQL-Query aus und gibt die erste Zeile
# als Array ihrer Spalten zurueck
	$q=$db->query($sql);
	if (DB::iserror($q)) {
		print "<H2><font color=\"red\">Datenbankfehler</font></H2>\n";
		print "<b>Fehlermeldung:</b> <kbd>" . $q->getMessage() . "</kbd><p />\n";
		print "bei folgendem SQL-Statement:<pre> $sql</pre>\n";
		print nochmalversuchenoderzurueck("javascript:history.back()");
		die();
	}
	if ($q->fetchInto($row)){ # Zeilen gefunden
			return $row;
	} else {
		print "<H2><font color=\"red\">Datenbankfehler</font></H2>\n";
		print "<b>Leere Antwortmenge:\n";
		print "bei folgendem SQL-Statement:<pre> $sql</pre>\n";
		print nochmalversuchenoderzurueck("javascript:history.back()");
		die();
	};
}

function sqldo ($sql,$db) {
# Fuehrt die uebergebene SQL-Query aus und gibt den 
# Wert der ersten Spalte des ersten Records 
# oder (bei nicht-select-Anweisungen) die Zahl der
# affected Rows zurueck.
	$q=$db->query($sql);
	if (DB::iserror($q)) {
		print "<H2><font color=\"red\">Datenbankfehler</font></H2>\n";
		print "<b>Fehlermeldung:</b> <kbd>" . $q->getMessage() . "</kbd><p />\n";;
		print "bei folgendem SQL-Statement:<pre> $sql</pre>\n";
		print nochmalversuchenoderzurueck("javascript:history.back()");
		die();
	}
	if (preg_match('/^select /i',$sql)) { # falls select
		if ($q->fetchInto($row)){
			return $row[0];
		} else {
			return 0;
		};
	} else { # falls nicht-select (z.B. update, delete)
		return $db->affectedRows();
	}
}

function sqlrows($sql,$db) {
# Fuehrt die uebergebene SQL-Query aus und gibt die Anzahl der Zeilen der Ergebnismenge zurueck
	$i=0;
	$q=$db->query($sql);
	if (DB::iserror($q)) {
		print "<H2><font color=\"red\">Datenbankfehler</font></H2>\n";
		print "<b>Fehlermeldung:</b> <kbd>" . $q->getMessage() . "</kbd><p />\n";;
		print "bei folgendem SQL-Statement:<pre> $sql</pre>\n";
		print nochmalversuchenoderzurueck("javascript:history.back()");
		die();
	}
	while ($q->fetchInto($row)) { $i++; }
	return $i;
}

function form() {
# Gibt den Beginn eines Formulares aus
	global $script;
	print "<form action=\"$script\" method=\"GET\">";
	if ($_GET['thenclose']) {
		print "<input type=hidden name=\"thenclose\" value=1>";
	}
}

function loeschennichtmoeglich() {
	return "<H3><font color=\"red\">L&ouml;schen nicht m&ouml;glich</font></H3>\n";
}

function nochmalversuchenoderzurueck($zurueck) {
	global $script;
	return "<p><a href=\"$script?" . $_SERVER['QUERY_STRING'] . "\">[nochmal versuchen]</a> oder <a href=\"$zurueck\">[zur&uuml;ck]</a>\n";
}

function wirklichloeschenoderzurueck($zurueck) {
	global $script;
	return "<p><br /><table border=1 cellpadding=5 cellspacing=0><tr><td bgcolor=\"#ddddff\"><a href=\"$script?" . $_SERVER['QUERY_STRING'] . "&sicher=1\">[Wirklich l&ouml;schen]</a> oder <a href=\"$zurueck\">[zur&uuml;ck]</a></td></tr></table>\n";
}

function inputclass($fieldname) { 
# gibt 'class="form-element" oder 'class=form-modified' an, je nachdem ob der uebergebene Name auch als CGI-Parameter uebergeben wurde
	return ' class="' . ( $_GET[$fieldname] ?"form-modified":"form-element") . '" ';
}

function hierfehltwas() { 
# Zeigt an, dass hier was fehlt
	print '<nobr><img src="images/triangle_right.gif">&nbsp;<b><font color=red>Pflichtfeld!</font></b></nobr>';
}

# Ersetzt ' und " durch entsprechende html-codes
function safesinglequotes($s) {
	return preg_replace("/'/","\\'",stripslashes($s));
}
function safedoublequotes($s) {
	return stripslashes(preg_replace('/"/','&quot;',$s));
}

# Datenbankverbindung aufbauen
function opendb() {
	require_once('DB.php');
	global $db,$DBCONNECT;
	$db=DB::connect($DBCONNECT,1);
	if (DB::iserror($q)) {
		die($q->getMessage());
	}
	return $db;
}

# Datenbankverbindung schliessen
function closedb($db)  {
   $db->disconnect();
} ?>
